\NeedsTeXFormat{LaTeX2e}[1995/06/01]
\ProvidesClass{plan-base}

\newif\ifplan@natbib
\plan@natbibtrue

\newif\ifplan@narrow
\plan@narrowfalse

\newif\ifdiss@fi
\diss@fifalse

\DeclareOption{nonatbib}{\plan@natbibfalse}
\DeclareOption{finnish}{\diss@fitrue}
\DeclareOption{english}{\diss@fifalse}
\DeclareOption{narrow}{\plan@narrowtrue}

\ProcessOptions
\LoadClass[11pt,a4paper]{artikel3}



\RequirePackage{ucs}
\RequirePackage[utf8x]{inputenc}
%\RequirePackage{palatcm}
\ifplan@narrow
\else
\textheight=250mm
\textwidth=170mm
\topmargin=15mm
\voffset=-3.0cm
\hoffset=-1.8cm
\unitlength=0.8mm
\fi

\RequirePackage[finnish,english]{babel}
\ifdiss@fi
\def\selectdefaultlanguage{\selectlanguage{finnish}}
\else
\def\selectdefaultlanguage{\selectlanguage{english}}
\fi

\RequirePackage[sf,bf,small]{titlesec}
\titlelabel{\thetitle.\ }
%\renewcommand{\TitleFont}{\bfseries\sffamily}

\renewcommand{\@maketitle}{
\newpage
\vspace*{15mm}
\par\noindent
{\Large\bfseries\sffamily \@title}
\par\noindent
\@author
\bigskip\bigskip
}

\tolerance=1000

\def\:{\nobreak-\hskip0mm} %%% TAVUVIIVA on \: 

\newcommand{\vv}{\vskip\bigskipamount}
\baselineskip10pt
%\parindent0truecm\parskip\bigskipamount
\parindent1em\parskip\bigskipamount
\baselineskip\smallskipamount
%\baselineskip\bigskipamount

% For theorems etc.
\topsep=\bigskipamount

\ifplan@natbib
 \RequirePackage[numbers]{natbib}
 \bibliographystyle{amsplnat}
 \renewcommand{\bibnumfmt}[1]{#1.}
 \renewcommand{\bibsection}{
        \section*{\refname}
         \setlength{\bibsep}{0.7ex}
         \def\bibfont{\small}
         \linespread{0.9}
         }
\else
  \def\@biblabel#1{#1.}
\fi

% For some reason this isn't automatic for the abstract.
\renewcommand*\SectFont{\sffamily\bfseries}
\renewcommand*\ParaFont{\sffamily\bfseries}

\renewcommand*\paragraph{%
  \@startsection{paragraph}{4}{\z@}%
    {1ex \@plus1ex \@minus.2ex}%
    {-1em}%
    {\normalfont\normalsize\ParaFont}}

