%
% Sample script to convert NIFTI data for tensorreg, 
% adding noise. This script exports the raw DWI signals
% for the whole 3D volume.
%


%
% Set up parameters for script
%

noises=[10 50];

% Export whole brawin
slice=[];
BASEPREFIX='brain_lownoise_raw';

% Export slice 23 only
%slice=23;
%BASEPREFIX='../brain_lownoise_raw_23';

%
% Load data (NIFTI format)
%

d0=dti_load_nii('../../../dti_lownoise/', ...
                'data_eddycorrect', ...
                '20100121_164850ep2ddiff2b12dgrpa2neus009a001', ...
                slice);


%
% Export noise-free data as raw doubles
%
tensorreg_export_raw([BASEPREFIX, '-f0'], d0);

%
% Generate and export noisy data as raw doubles
%
for j=1:length(noises)
    noise=noises(j);
    d=d0; 
    d.I=ricernd(d0.I, noise);
    name=sprintf('%s-f%d', BASEPREFIX, noise);
    tensorreg_export_raw(name, d);
end

