%
% dticode/matlab/calc_EXPAND.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
% calc_EXPAND calculates the matrix for the expansion 
% of a tensor of signature sig from symmetric presentation 
% to full presentation.
%
function M=calc_EXPAND(sig)
    dim=sig(1);
    order=sig(2);
    
    ss=tsize_sym(sig);
    ns=tsize_nonsym(sig);
    
    M=zeros(ns, ss);
    
    Is=indices(sig);
    
    for l=1:size(Is, 1)
        j=index_sym(sig, Is(l, :));
        k=index_ns(sig, Is(l, :));
        M(k, j)=1;
    end
end
