%
% dticode/matlab/dti_load_nii.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
function d=dti_load_nii(dir, dataprefix, bvprefix, slice)
    if isempty(bvprefix)
        bvprefix=dataprefix;
    end
    nii=load_untouch_nii([dir, '/', dataprefix, '.nii']);%, [], [], [], [], [], 1);
    bvec=load([dir, '/', bvprefix, '.bvec']);
    bval=load([dir, '/', bvprefix, '.bval']);
    
    s=size(nii.img);
    
    img=nii.hdr.dime.scl_slope*double(nii.img)+nii.hdr.dime.scl_inter;
    
    d={};
    if nargin>=4 && ~isempty(slice)
        d.I=img(:, :, slice, :);
        d.bvec=bvec;
        d.bval=bval;
    else
        d.I=img;
        d.bvec=bvec;
        d.bval=bval;
    end
end
