%
% dticode/matlab/index_sym.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
% Returns the index into the symmetric presentation (vector)
% of a tensor of signature sig, for the index vector ii
% consisting of coordinate-wise indices.
%
% The signature sig=[dim order width height depth], 
% where DIM is the dimension of the variables, and ORDER
% the order of the tensors.
%
function i=index_sym(sig, ii)
    dim=sig(1);
    order=length(ii);
    BELOW=symbelowmat([dim order]);
    i=1;
    ii=sort(ii);
    for j=1:length(ii);
        i=i+BELOW(ii(j)+1, j);
    end
end

function i=index_sym_(sig, ii)
    dim=sig(1);
    order=length(ii);
    % assert(sig(2)==length(ii);
    if dim==2
        i=order+1-sum(1-ii);
    end
end
