function log=read_log(logfile)
    disp(['Scanning log file ', logfile])
    iters=0;
    iters_thisfb=0;
    fbiter=0;
    times=struct();
    fid=fopen(logfile, 'r');
    if fid<0
        warning(['Log not found: ', logfile]);
        return;
    end
    while 1
        line=fgetl(fid);
        if ~ischar(line)
            break
        end
        match=regexp(line, '^\[(\d+)/(\d+)\]', 'tokens');
        if ~isempty(match)
            iters_thisfb=str2num(match{1}{1});
            continue
        end
        match=regexp(line, '^time\s+([^0-9]+)\s+([0-9.]+)s', 'tokens');
        if ~isempty(match)
            fname=regexprep(match{1}{1}, '\((.*)\)', '_$1');
            times=setfield(times, fname, match{1}{2});
            continue
        end
        match=regexp(line, '^.*\s+iteration\s+(\d+)/max', 'tokens');
        if ~isempty(match)
            fbiter=str2num(match{1}{1});
            iters=iters+iters_thisfb;
            iters_thisfb=0;
            continue
        end
    end
    log.iters=iters+iters_thisfb;
    log.fbiter=fbiter;
    log.times=times;
end
