%
% dticode/matlab/sym2eigs_multi_.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
% This is a highly inefficient implementation for computing
% the eigenvalues and eigenvectors of all the tensors in u.
% It is only provided in case there are problems compiling
% the Mex implementation, which should be used if at all
% possible.
%
function [L, E]=sym2eigs_multi_(u)
    dim=sym2dim(u);
    L=zeros(dim, size(u, 2));
    E=zeros(dim, dim, size(u, 2));
    parfor i=1:size(u, 2)
        M=symprestomat(u(:, i));
        [e, l]=eig(M);
        L(:, i)=diag(l);
        E(:, :, i)=e';
    end
end
