%
% dticode/matlab/sym2eigs_multi_principal.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
% A little bit faster than sym2eigs_multi_sorted
% when only principal eigenvalue and vector are needed.
function [L, E]=sym2eigs_multi_principal(u)
    if nargout>1
        [L1, E1]=sym2eigs_multi(u);
        [L,I]=max(L1, [], 1);
        E=zeros(1, size(E1, 2), size(E1, 3));
        %for j=1:size(E, 3)
        %    E(1, :, j)=E1(I(j), :, j);
        %end
        nevs=size(E1, 1);
        els=size(E1, 2);
        nel=size(E1, 3);
        eld=1:els;
        eli=(0:(nel-1))*nevs*els;
        pick=eli+I;
        for i=eld
            E(1, i, :)=E1(pick+(i-1)*els);
            %E(1, i, :)=E1(sub2ind(size(E1), I, repmat(i, 1, nel), 1:nel));
        end
    else
        L1=sym2eigs_multi(u);
        L=max(L1, [], 1);
    end
