%
% dticode/matlab/sym2reconstruct_multi.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
function res=sym2reconstruct_multi(L, E)
    dim=size(L, 1);
    
    if dim==1
        res=L.*E;
    elseif dim==2
        mu1=L(1, :);
        mu2=L(2, :);
        e11=squeeze(E(1, 1, :))';
        e12=squeeze(E(1, 2, :))';
        e21=squeeze(E(2, 1, :))';
        e22=squeeze(E(2, 2, :))';
        res=zeros(3, size(L, 2));
        %res(index2([2 0]), :)=mu1.*E(1, 1, :).^2+mu2.*E(2, 1, :).^2;
        %res(index2([0 2]), :)=mu1.*E(1, 2, :).^2+mu2.*E(2, 2, :).^2;
        %res(index2([1 1]), :)=mu1.*E(1, 1, :).*E(1, 2, :)+mu2.*E(2, 1, :).*E(2, 2, :);
        res(index_sym(2, [0 0]), :)=mu1.*e11.^2+mu2.*e21.^2;
        res(index_sym(2, [1 1]), :)=mu1.*e12.^2+mu2.*e22.^2;
        res(index_sym(2, [0 1]), :)=mu1.*e11.*e12+mu2.*e21.*e22;
    elseif dim==3
        res=zeros(tsize_sym([dim 2]), size(L, 2));
        i00=index_sym(3, [0 0]);
        i01=index_sym(3, [0 1]);
        i11=index_sym(3, [1 1]);
        i02=index_sym(3, [0 2]);
        i12=index_sym(3, [1 2]);
        i22=index_sym(3, [2 2]);
        
        for i=1:3
            mu=L(i, :);
            ex=squeeze(E(i, 1, :))';
            ey=squeeze(E(i, 2, :))';
            ez=squeeze(E(i, 3, :))';
            
            res(i00, :)=res(i00, :)+mu.*ex.*ex;
            res(i11, :)=res(i11, :)+mu.*ey.*ey;
            res(i22, :)=res(i22, :)+mu.*ez.*ez;
            res(i01, :)=res(i01, :)+mu.*ex.*ey;
            res(i02, :)=res(i02, :)+mu.*ex.*ez;
            res(i12, :)=res(i12, :)+mu.*ey.*ez;
        end
    else
        error('sym2reconstruct_multi not implemented for requested dimension');
    end
end

    