%
% dticode/matlab/sympres.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
% Transforms 2nd and 3rd order tensors into their
% symmetric presentation (matlab vector) from the
% corresponding 2D or 3D matlab array.
%
function res=sympres(A)
    if size(A, 1)==2
        res=zeros(3, 1);
        res(index_sym(2, [0 0]))=A(1, 1);
        res(index_sym(2, [1 1]))=A(2, 2);
        res(index_sym(2, [0 1]))=A(1, 2);
    elseif size(A, 1)==3
        res=zeros(6, 1);
        res(index_sym(3, [0 0]))=A(1, 1);
        res(index_sym(3, [1 1]))=A(2, 2);
        res(index_sym(3, [2 2]))=A(3, 3);
        res(index_sym(3, [0 1]))=A(1, 2);
        res(index_sym(3, [0 2]))=A(1, 3);
        res(index_sym(3, [1 2]))=A(2, 3);
    else
        error('sympres not implemented for requested dimension')
    end
end
