%
% dticode/matlab/symprestomat.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
% Transforms 2nd and 3rd order tensors from their
% symmetric presentation (matlab vector) to the
% corresponding 2D or 3D matlab array.
%
function M=symprestomat(A)
    d=sym2dim(A);
    if d==2
        M(1, 1)=A(index_sym(2, [0 0]));
        M(2, 2)=A(index_sym(2, [1 1]));
        M(1, 2)=A(index_sym(2, [0 1]));
        M(2, 1)=M(1, 2);
    elseif d==3
        M(1, 1)=A(index_sym(3, [0 0]));
        M(2, 2)=A(index_sym(3, [1 1]));
        M(3, 3)=A(index_sym(3, [2 2]));
        M(1, 2)=A(index_sym(3, [0 1]));
        M(2, 1)=M(1, 2);
        M(1, 3)=A(index_sym(3, [0 2]));
        M(3, 1)=M(1, 3);
        M(2, 3)=A(index_sym(3, [1 2]));
        M(3, 2)=M(2, 3);
    else
        error('symprestomat not implemented for requested dimension')
    end
end
