%
% dticode/matlab/tensorreg_export.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
function tensorreg_export(name, sig, f, mask)
    infile=[name, '.doubles'];
    write_doubles(infile, f);
    save([name, '-mask.mat'], 'mask');

    parf=fopen([name, '.params'], 'w');
    
    fprintf(parf, '-dim %d\n', sig(1));
    fprintf(parf, '-order %d\n', sig(2));
    fprintf(parf, '-width %d\n', sig(3));
    fprintf(parf, '-height %d\n', sig(4));
    if length(sig)>=5
        fprintf(parf, '-depth %d\n', sig(5));
    end
    fprintf(parf, '-infile %s\n', infile);
    
    fclose(parf);
end
