%
% dticode/matlab/tensorreg_import_raw.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
function [res, mask]=tensorreg_import_raw(name, sig, vals)
    resfile=[name, '.doubles'];
    
    load([name, '-mask.mat'], 'mask');

    amatfile=[name, '-amat.doubles'];
    ts=tsize_sym(sig);
    voxels=prod(sig(3:end));
    A=read_doubles(amatfile, [vals, ts]);
    c=read_doubles(resfile, [vals, voxels]);
    res=zeros(ts, voxels);
    ok=all(isreal(c) & isfinite(c), 1);
    res(:, ok)=A \ c(:, ok);
end
