/*
 * dticode/src/acc_support.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */

#ifndef _ACC_SUPPORT_H
#define _ACC_SUPPORT_H

#include <libtu/types.h>
#include "number.h"

/* Just a notation help for device pointers */
#define DEVPTR /* */

void memcpy_to_dev(void * DEVPTR devptr, const void *hostptr, size_t n);
void memcpy_from_dev(void *hostptr, const void * DEVPTR devptr, size_t n);

void veccopy_to_dev(FNumber * DEVPTR devptr, const FNumber *src, size_t n);
void veccopy_from_dev(FNumber *ptr, const FNumber * DEVPTR devsrc, size_t n);

FNumber *vector_to_dev(FNumber *ptr, size_t n, bool free);
FNumber *vector_from_dev(FNumber * DEVPTR devptr, size_t n, bool free);

void memcpy_dev(void * DEVPTR devptr, const void * DEVPTR deptr2, size_t n);

#if _OPENACC
#include <openacc.h>
#define HWALLOC acc_malloc
#define HWFREE acc_free
#else
#define HWALLOC malloc
#define HWFREE free
#endif

#endif /* _ACC_SUPPORT_H */
