/*
 * dticode/src/combine_nonlin.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _COMBINE_NONLIN_H
#define _COMBINE_NONLIN_H

#include "cpock_nonlin.h"
#include "combine.h"

typedef void FidNLK(FidDual *phi, const FidPrimal *u, bool addto_phi, FidParams *p);
typedef void FidNLKAG(FidDual *phi, const FidPrimal *u0, const FidPrimal *u, bool addto_phi, FidParams *p);
typedef void FidNLKC(FidPrimal *u, const FidPrimal *u0, const FidDual *phi, bool addto_u, FidParams *p);

typedef struct{
    Fid lin;
    FidNLK *nl_k;
    FidNLKAG *nl_kag;
    FidNLKC *nl_kc;
} FidNL;

extern FidPrimal *combine_do_cpock_nonlin(CPockParam *cpockp,
                                          const FidNL *fid, FidParams *fidp,
                                          const Reg *reg, RegParams *regp,
                                          FidInitPrimalStyle initstyle, 
                                          const void *initparam);

typedef struct{
    ModelParams *fidp;
    ModelParams *regp;
    const FidNL *fid;
    const Reg *reg;
} CombinedNLParams;

extern CPockNLFn combined_nl_fn;

extern CombinedDual *combined_nl_alloc_dual(CombinedNLParams *cp);
extern CombinedPrimal *combined_nl_alloc_primal(CombinedNLParams *cp);

#endif /* _COMBINE_NONLIN_H */
