/*
 * dticode/src/cpock_nonlin.h
 *
 * Written 2012-2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz and 
 *                                                      University of Cambridge.
 *
 */


#ifndef _CPOCK_NONLIN_H
#define _CPOCK_NONLIN_H

#include <libtu/types.h>
#include "number.h"
#include "cpock_accel.h"
#include "combine.h"

typedef void CPockNLK(Dual *a, const Primal *b, ModelParams *mp);
typedef void CPockNLKAG(Dual *a, const Primal *b, const Primal *c, ModelParams *mp);
typedef void CPockNLKC(Primal *a, const Primal *b0, const Dual *b, ModelParams *mp);
typedef FNumber CPockNLEstimate(Estimate estim, const Primal *a, ModelParams *mp);

typedef struct{
    CPockNLK *nl_k;
    CPockNLKAG *nl_kag;
    CPockNLKC *nl_kc;
    CPockFCres *fcres;
    CPockGres *gres;
    CPockNLEstimate *nl_estimate;
    //CPockPDgap *pdgap;
} CPockNLFn;



extern void cpock_nonlin(Primal *xres, Dual *yres, 
                         Primal *x, Dual *y, 
                         Primal *xtmp, Dual *ytmp, 
                         const CPockParam *p, 
                         const CPockNLFn *fn,
                         ModelParams *mp);

#endif /* _CPOCK_NONLIN_H */
