/*
 * dticode/src/diff.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */

#ifndef _DIFF_H
#define _DIFF_H

#include "tensor.h"
#include "number.h"

void tensorfield_symgrad(TensorField *res, const TensorField *u, 
                         FNumber alpha, FNumber beta,
                         int boundary, char alg);

void tensorfield_negsymdiv(TensorField *res, const TensorField *u, 
                           FNumber alpha, FNumber beta,
                           int boundary, char alg);

void tensorfield_grad(TensorField *res, const TensorField *u, 
                      FNumber alpha, FNumber beta,
                      int boundary, char alg);

void tensorfield_negdiv(TensorField *res, const TensorField *u, 
                        FNumber alpha, FNumber beta,
                        int boundary, char alg);

extern FNumber calc_l2fact(const Sig *sig, char alg);

#endif /* _DIFF_H */
