/*
 * dticode/src/diff_workers.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */


#ifndef _DIFF_WORKERS_H
#define _DIFF_WORKERS_H

#include <stdlib.h>

#include "tensor.h"
#include "number.h"
#include "sparse.h"
#include "acc_support.h"

typedef void DiffWorker(size_t resdim, size_t dim,
                        size_t w, size_t h, size_t d,
                        FNumber xres, FNumber yres, FNumber zres,
                        FNumber * DEVPTR res, const FNumber * DEVPTR a,
                        FNumber alpha, FNumber beta,
                        const SparseMatrix *pm);

#define _DEFINE_DIFF_SELECTOR(NAME) \
   DiffWorker *NAME(const Sig *sig, \
                    FNumber alpha, FNumber beta, \
                    int bdry, char alg, \
                    const SparseMatrix **pm)

#define _CALL_DIFF_SELECTOR(NAME) NAME(sig, alpha, beta, bdry, alg, pm)

typedef _DEFINE_DIFF_SELECTOR(DiffSelector);

#endif /* _DIFF_WORKERS_H */
