/*
 * dticode/src/diffoper_complex.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_COMPLEX_H
#define _DIFFOPER_COMPLEX_H

#include "diffoper.h"
#include "tensor.h"
#include "splitvar.h"

INTRCLASS(DOperComplex);

DECLCLASS(DOperComplex){
    DOper doper;
    Sig sig;
};

typedef SplitVar DOperComplexDom;
typedef TensorField DOperComplexCod;

extern bool diffoper_complex_init(DOperComplex *op, const Sig *sig);

extern void diffoper_complex_deinit(DOperComplex *op);

extern DOperComplex *create_diffoper_complex(const Sig *sig);

#endif /* _DIFFOPER_COMPLEX_H */
