/*
 * dticode/src/diffoper_dti.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_DTI_H
#define _DIFFOPER_DTI_H

#include "diffoper.h"
#include "tensor.h"
#include "splitvar.h"
#include "matrix.h"

INTRCLASS(DOperDTI);
INTRCLASS(DOperDTINonNeg);

DECLCLASS(DOperDTI){
    DOper doper;
    Sig sig;
    const Matrix *bmat;
    FNumber bmat_opnorm;
    const TensorField *s0;
};

DECLCLASS(DOperDTINonNeg){
    DOperDTI dti;
};

typedef TensorField DOperDTIDom;
typedef TensorField DOperDTICod;

extern bool diffoper_dti_init(DOperDTI *op, 
                              const Sig *sig,
                              const Matrix *bmat,
                              const TensorField *s0);

extern void diffoper_dti_deinit(DOperDTI *op);

extern DOperDTI *create_diffoper_dti(const Sig *sig, 
                                     const Matrix *bmat,
                                     const TensorField *s0);

extern DOperDTINonNeg *create_diffoper_dti_nonneg(const Sig *sig, 
                                                  const Matrix *bmat,
                                                  const TensorField *s0);

#endif /* _DIFFOPER_DTI_H */
