/*
 * dticode/src/diffoper_dtis.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_DTIS_H
#define _DIFFOPER_DTIS_H

#include "diffoper.h"
#include "tensor.h"
#include "splitvar.h"
#include "matrix.h"

INTRCLASS(DOperDTIS);
INTRCLASS(DOperDTISNonNeg);

DECLCLASS(DOperDTIS){
    DOper doper;
    Sig sig;
    const Matrix *bmat;
    FNumber bmat_opnorm;
    const TensorField *s0;
};

DECLCLASS(DOperDTISNonNeg){
    DOperDTIS dtis;
};

typedef SplitVar DOperDTISDom;
typedef TensorField DOperDTISCod;

extern bool diffoper_dtis_init(DOperDTIS *op, 
                               const Sig *sig,
                               const Matrix *bmat,
                               const TensorField *s0);

extern void diffoper_dtis_deinit(DOperDTIS *op);

extern DOperDTIS *create_diffoper_dtis(const Sig *sig, 
                                       const Matrix *bmat,
                                       const TensorField *s0);

extern DOperDTISNonNeg *create_diffoper_dtis_nonneg(const Sig *sig, 
                                                   const Matrix *bmat,
                                                   const TensorField *s0);

#endif /* _DIFFOPER_DTIS_H */
