/*
 * dticode/src/diffoper_multiply.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_MULTIPLY_H
#define _DIFFOPER_MULTIPLY_H

#include "diffoper.h"
#include "tensor.h"
#include "splitvar.h"

INTRCLASS(DOperMultiply);

DECLCLASS(DOperMultiply){
    DOper doper;
    Sig sig;
    bool dom1_is_complex;
    bool dom2_is_complex;
};

typedef SplitVar DOperMultiplyDom;
typedef TensorField DOperMultiplyCod;

extern bool diffoper_multiply_init(DOperMultiply *op, 
                                   const Sig *sig,
                                   bool dom1_is_complex,
                                   bool dom2_is_complex);

extern void diffoper_multiply_deinit(DOperMultiply *op);

extern DOperMultiply *create_diffoper_multiply(const Sig *sig,
                                               bool dom1_is_complex,
                                               bool dom2_is_complex);

#endif /* _DIFFOPER_MULTIPLY_H */
