/*
 * dticode/src/diffoper_norm.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_NORM_H
#define _DIFFOPER_NORM_H

#include "diffoper.h"
#include "tensor.h"

INTRCLASS(DOperNorm);

DECLCLASS(DOperNorm){
    DOper doper;
    Sig sig;
    FNumber eps;
};

typedef TensorField DOperNormDom;
typedef TensorField DOperNormCod;

extern bool diffoper_norm_init(DOperNorm *op, const Sig *sig, FNumber eps);

extern void diffoper_norm_deinit(DOperNorm *op);

extern DOperNorm *create_diffoper_norm(const Sig *sig, FNumber eps);

#endif /* _DIFFOPER_NORM_H */
