/*
 * dticode/src/diffoper_phasediff.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_PHASEDIFF_H
#define _DIFFOPER_PHASEDIFF_H

#include "diffoper.h"
#include "tensor.h"
#include "splitvar.h"

INTRCLASS(DOperPhaseDiff);

DECLCLASS(DOperPhaseDiff){
    DOper doper;
    Sig sig;
    FNumber phi1mult1, phi1mult2;
    FNumber phi2mult1, phi2mult2;
};

typedef SplitVar DOperPhaseDiffDom;
typedef SplitVar DOperPhaseDiffCod;

extern bool diffoper_phasediff_init(DOperPhaseDiff *op, const Sig *sig);

extern void diffoper_phasediff_deinit(DOperPhaseDiff *op);

extern DOperPhaseDiff *create_diffoper_phasediff(const Sig *sig);

#endif /* _DIFFOPER_PHASEDIFF_H */
