/*
 * dticode/src/diffoper_split.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_SPLIT_H
#define _DIFFOPER_SPLIT_H

#include "diffoper.h"
#include "linoper.h"
#include "splitvar.h"

INTRCLASS(DOperSplit);

DECLCLASS(DOperSplit){
    DOper doper;
    DOper **dops;
    size_t n_dops;
};

typedef SplitVar DOperSplitDom;
typedef SplitVar DOperSplitCod;

extern bool diffoper_split_init(DOperSplit *op, 
                                DOper **dops, 
                                size_t n_dops);

extern void diffoper_split_deinit(DOperSplit *op);

extern DOperSplit *create_diffoper_split(DOper **dops, size_t n_dops);

#endif /* _DIFFOPER_SPLIT_H */
