/*
 * dticode/src/diffoper_splitsame.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _DIFFOPER_SPLITSAME_H
#define _DIFFOPER_SPLITSAME_H

#include "diffoper.h"
#include "linoper.h"
#include "splitvar.h"
#include "vector.h"

INTRCLASS(DOperSplitSame);

DECLCLASS(DOperSplitSame){
    DOper doper;
    DOper **dops;
    size_t n_dops;
};

typedef Vector DOperSplitSameDom;
typedef SplitVar DOperSplitSameCod;

extern bool diffoper_splitsame_init(DOperSplitSame *op, 
                                    DOper **dops, 
                                    size_t n_dops);

extern void diffoper_splitsame_deinit(DOperSplitSame *op);

extern DOperSplitSame *create_diffoper_splitsame(DOper **dops, size_t n_dops);

#endif /* _DIFFOPER_SPLITSAME_H */
