/*
 * dticode/src/doubleio.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */
 
#ifndef _DOUBLEIO_H
#define _DOUBLEIO_H

#include <stddef.h>
#include <stdio.h>

#include "number.h"

typedef bool ReadFn(const double *buf, size_t idx, size_t bs, void *fp);
typedef bool WriteFn(double *buf, size_t idx, size_t bs, void *fp);

extern ReadFn readfn_simple;
extern WriteFn writefn_simple;
extern ReadFn readfn_simple_acc;
extern WriteFn writefn_simple_acc;

size_t read_doubles(size_t nblocks, size_t blocksize, FILE *f, 
                    ReadFn *fn, void *fp);

size_t write_doubles(size_t nblocks, size_t blocksize, FILE *f,
                     WriteFn *fn, void *fp);

void read_doublefile(size_t nblocks, size_t blocksize, const char *file,
                     ReadFn *fn, void *fp);

void write_doublefile(size_t nblocks, size_t blocksize, const char *file,
                      WriteFn *fn, void *fp);

#endif /* _DOUBLEIO_H */
