/*
 * dticode/src/fft.h
 *
 * Written 2012-2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */

#ifndef _FFT_H
#define _FFT_H

#include <libtu/types.h>

#include "number.h"
#include "tensor.h"

void fftshift(int rank, const int *dims, 
              FNumber *res, const FNumber *src, 
              bool inverse);

void do_fft(int rank, const int *dims, 
            FNumber *res, const FNumber *src);

void do_ifft(int rank, const int *dims, 
             FNumber *res, const FNumber *src);

void fft_init_params(size_t *rank, int dims[3], FNumber *normfact, 
                     const Sig *sig);

void fft_init();
void fft_finalise();

#endif /* _FFT_H */
