/*
 * dticode/src/fftop.c
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */

#include <string.h>
#include <libtu/output.h>
#include "linoper.h"
#include "linoper_sparsefft.h"
#include "linoper_nufft.h"
#include "tensor.h"

LinOper *load_fftop(const char *infile, const Sig *sig, const char *datadomain, TensorField **f)
{
    LinOper *fftop=NULL;
    
    if(strcmp(datadomain, "kspace")==0)
        fftop=(LinOper*)load_linoper_sparsefft(infile, sig, FALSE, f);
    else if(strcmp(datadomain, "kspace-sparse")==0)
        fftop=(LinOper*)load_linoper_sparsefft(infile, sig, TRUE, f);
    else if(strcmp(datadomain, "kspace-nonuniform")==0)
        fftop=(LinOper*)load_linoper_nufft(infile, sig, f);
    else
        die("Invalid data domain %s.", datadomain);
        
    return fftop;
}

LinOper *load_fftop_nodata(const char *infile, const Sig *sig, const char *datadomain, Sig *fsig)
{
    LinOper *fftop=NULL;
    
    if(strcmp(datadomain, "kspace")==0)
        fftop=(LinOper*)load_linoper_sparsefft_nodata(infile, sig, FALSE, fsig);
    else if(strcmp(datadomain, "kspace-sparse")==0)
        fftop=(LinOper*)load_linoper_sparsefft_nodata(infile, sig, TRUE, fsig);
    else if(strcmp(datadomain, "kspace-nonuniform")==0)
        fftop=(LinOper*)load_linoper_nufft_nodata(infile, sig, fsig);
    else
        die("Invalid data domain %s.", datadomain);
        
    return fftop;
}
