/*
 * dticode/src/reg.c
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */

#include <stdlib.h>
#include <string.h>
#include <libtu/output.h>
#include <libtu/misc.h>
#include "fid_po.h"
#include "fid_l1.h"
#include "fid_l2.h"
#include "fid_l2alt.h"
#include "cpock_accel.h"
#include "fid.h"

void init_fidelity(Fid **fid, FidP *fidp, const char *fidname, LinOper *op, TensorField *f, TensorField *lb, TensorField *rb)
{
    if(strcmp(fidname, "l2")==0){
        if(!OBJ_IS(op, LinOperL2))
            die("Cannot use l2 fidelity with this operator. Use l2alt.");
        fid_l2_init(f, (LinOperL2*)op, fid, &fidp->l2);
    }else if(strcmp(fidname, "l1")==0){
        fid_l1_init(f, op,  fid, &fidp->l1);
    }else if(strcmp(fidname, "l2alt")==0 || strcmp(fidname, "l2alt-nl")==0){
        fid_l2alt_init(f, op, fid, &fidp->l2alt);
	}else if (strcmp(fidname, "po")==0){
		fid_po_init(lb, rb, f, op,  fid, &fidp->po);
    }else{
        die("Invalid fidelity function: %s", fidname);
    }
}
