/*
 * dticode/src/fid.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _FID_H 
#define _FID_H

#include "fid_po.h"
#include "fid_l1.h"
#include "fid_l2.h"
#include "fid_l2alt.h"
#include "fid_oper.h"
#include "fid_split.h"
#include "cpock_accel.h"

typedef union{
    FidL2Params l2;
    FidL2AltParams l2alt;
    FidL1Params l1;
    FidPOParams po;
    FidOperParams oper;
    FidSplitParams split;
} FidP;

void init_fidelity(Fid **fid, FidP *fidp, const char *fidname, LinOper *op, TensorField *f, TensorField *lb, TensorField *rb);

#endif /* _FID_H */
