/*
 * dticode/src/fid_l2alt.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _FID_L2ALT_H
#define _FID_L2ALT_H

#include "tensor.h"
#include "combine.h"
#include "linoper.h"

typedef LinOperDom FidL2AltPrimal;
typedef LinOperCod FidL2AltDual;

typedef struct{
    const LinOperCod *f;
    const LinOperCod *f_orig;
    LinOperCod *f_tmp;
    LinOper *op;
    const TensorField *mask;
    FNumber mask_term_weight;
    FNumber pdgap0_ab;
    FNumber pdgap0_c;
    FNumber primal_bound;
} FidL2AltParams;


void fid_l2alt_init(const LinOperCod *f, 
                    LinOper *op,
                    Fid **fid, 
                    FidL2AltParams *param);

FNumber fid_l2alt_baseshift(FidL2AltPrimal *u, FidBaseshiftMode mode, 
                            FidL2AltParams *fp);

void fid_l2alt_init_primal(FidL2AltPrimal *u, FidInitPrimalStyle initstyle, 
                           FidL2AltParams *fp);

bool fid_l2alt_grad(FidL2AltPrimal *grad, const FidL2AltPrimal *u, 
                    FidL2AltParams *fp);

#endif /* _FID_L2ALT_H */
