/*
 * dticode/src/fid_oper.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _FID_OPER_H 
#define _FID_OPER_H

#include <libtu/types.h>
#include <libtu/obj.h>
#include "cpock_accel.h"
#include "combine.h"
#include "combine_nonlin.h"
#include "number.h"
#include "diffoper.h"

INTRSTRUCT(FidOperParams);

typedef void FidOperGres(DOperDom *a, FNumber tau, FidOperParams *spp);

DECLSTRUCT(FidOperParams){
    Fid *fid;
    FidParams *fidp;
    DOper *oper;
    DOperDom *oper_u0;
    DOperDom *xi;
    DOperCod *tmp;
    FidOperGres *gres;
    FNumber pdgap0_ab;
    FNumber pdgap0_c;
    FNumber primal_bound;
};

extern void fid_oper_init(Fid *fid, FidParams *fidp, DOper *oper, 
                          Fid **fid_ret, FidOperParams *fop);

extern void fid_oper_init_nonlin(Fid *fid, FidParams *fidp, DOper *oper, 
                                 FidNL **fid_ret, FidOperParams *fop);

extern FidOperGres fid_oper_zero_gres;

#endif /* _FID_OPER_H */
