/*
 * dticode/src/fid_l2.h
 *
 */


#ifndef _FID_PO_H
#define _FID_PO_H

#include "tensor.h"
#include "combine.h"
#include "combine_nonlin.h"
#include "linoper.h"
#include "fid_l2alt.h"

typedef LinOperDom FidPOPrimal;
typedef TensorField FidPODual;
typedef struct{
    const LinOperCod *lb;
	const LinOperCod *rb;
	const LinOperCod *f;
    const LinOperCod *f_orig;
    LinOperCod *f_tmp;
    LinOper *op;
    const TensorField *mask;
    FNumber mask_term_weight;
    FNumber pdgap0_ab;
    FNumber pdgap0_c;
    FNumber primal_bound;
} FidPOParams;

void fid_po_init(const LinOperCod *lb, const LinOperCod *rb, const LinOperCod *f, 
                 LinOper *op,
                 Fid **fid, 
                 FidPOParams *param);

#endif /* _FID_PO_H */
