/*
 * dticode/src/linoper_grad.h
 *
 * Written 2014 by Tuomo Valkonen <tuomov@iki.fi>, EPN Quito.
 *
 */

#ifndef _LINOPER_GRAD_H
#define _LINOPER_GRAD_H

#include <libtu/types.h>
#include <libtu/obj.h>
#include "tensor.h"
#include "vector.h"
#include "number.h"
#include "linoper.h"

typedef TensorField LinOperGradCod;
typedef TensorField LinOperGradDom;

INTRCLASS(LinOperGrad);

DECLCLASS(LinOperGrad){
    LinOper linoper;
    Sig sig;
    bool symmetric;
    char diffalg;
};

extern void linoper_grad_deinit(LinOperGrad *op);

extern bool linoper_grad_init(LinOperGrad *op, const Sig *sig, 
                              bool symmetric, const char *diffalg);

extern LinOperGrad *alloc_linoper_grad(const Sig *sig,
                                       bool symmetric, const char *diffalg);

#endif /* _LINOPER_GRAD_H */
