/*
 * dticode/src/linoper_id.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */

#ifndef _LINOPER_ID_H
#define _LINOPER_ID_H

#include <libtu/types.h>
#include <libtu/obj.h>
#include "tensor.h"
#include "vector.h"
#include "number.h"
#include "linoper.h"

typedef TensorField LinOperIdCod;
typedef TensorField LinOperIdDom;

INTRCLASS(LinOperId);

DECLCLASS(LinOperId){
    LinOperL2 linoperl2;
    Sig sig;
};

extern void linoper_id_deinit(LinOperId *op);

extern bool linoper_id_init(LinOperId *op, const Sig *sig);

extern LinOperId *alloc_linoper_id(const Sig *sig);

#endif /* _LINOPER_ID_H */
