/*
 * dticode/src/linoper_multiply_by.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _LINOPER_MULTIPLY_BY_H
#define _LINOPER_MULTIPLY_BY_H

#include "tensor.h"
#include "linoper.h"

INTRCLASS(LinOperMultiplyBy);

DECLCLASS(LinOperMultiplyBy){
    LinOper loper;
    Sig sig;
    TensorField *w;
};

typedef TensorField LinOperMultiplyByDom;
typedef TensorField LinOperMultiplyByCod;

extern bool linoper_multiply_by_init(LinOperMultiplyBy *op, 
                                     const Sig *sig,
                                     TensorField *w);

extern void linoper_multiply_by_deinit(LinOperMultiplyBy *op);

extern LinOperMultiplyBy *create_linoper_multiply_by(const Sig *sig,
                                                     TensorField *w);

#endif /* _LINOPER_MULTIPLY_BY_H */
