/*
 * dticode/src/linoper_parallel.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _LINOPER_PARALLEL_H
#define _LINOPER_PARALLEL_H

#include "diffoper.h"
#include "linoper.h"
#include "splitvar.h"

INTRCLASS(LinOperParallel);

DECLCLASS(LinOperParallel){
    LinOper loper;
    LinOper *lop;
    size_t n;
};

typedef SplitVar LinOperParallelDom;
typedef SplitVar LinOperParallelCod;

extern bool linoper_parallel_init(LinOperParallel *op, 
                                  LinOper *lop, 
                                  size_t n);

extern void linoper_parallel_deinit(LinOperParallel *op);

extern LinOperParallel *create_linoper_parallel(LinOper *lops, size_t n);

#endif /* _LINOPER_PARALLEL_H */
