/*
 * dticode/src/linoper_split.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _LINOPER_SPLIT_H
#define _LINOPER_SPLIT_H

#include "diffoper.h"
#include "linoper.h"
#include "splitvar.h"

INTRCLASS(LinOperSplit);

DECLCLASS(LinOperSplit){
    LinOper loper;
    LinOper **lops;
    size_t n;
};

typedef SplitVar LinOperSplitDom;
typedef SplitVar LinOperSplitCod;

extern bool linoper_split_init(LinOperSplit *op, 
                               LinOper **lops, 
                               size_t n);

extern void linoper_split_deinit(LinOperSplit *op);

extern LinOperSplit *create_linoper_split(LinOper **lops, size_t n);

#endif /* _LINOPER_SPLIT_H */
