/*
 * dticode/src/diffoper_multiply.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _MULTIPLY_H
#define _MULTIPLY_H

#include "tensor.h"


// y = x1*x2
extern void tensorfield_multiply_pointwise(TensorField *y, 
                                           const TensorField *x1, 
                                           const TensorField *x2, 
                                           bool addto_y);

// y = conj(x1)*x2
extern void tensorfield_multiply_pointwise_conj(TensorField *y, 
                                                const TensorField *x1, 
                                                const TensorField *x2, 
                                                bool addto_y);

// y = x1/x2
extern void tensorfield_divide_pointwise(TensorField *y, 
                                         const TensorField *x1, 
                                         const TensorField *x2, 
                                         bool addto_y);

#endif /* _MULTIPLY_H */
