/*
 * dticode/src/normalise_worker_template.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */

static void WORKER(size_t dim, size_t n, FNumber * restrict DEVPTR ga,
                   FNumber alpha, const FNumber * restrict DEVPTR weight)
{
    size_t i;
    size_t dimn=dim*n;

    #pragma omp parallel for
#if APPLY_WEIGHT==1    
    #pragma acc kernels loop gang, vector, independent, \
        deviceptr(ga, weight)
#else
    #pragma acc kernels loop gang, vector, independent, \
        deviceptr(ga)
#endif


     
    


/*for(i=0; i<dimn; i+=dim){
        FNumber *a=ga+i;*/
    for(i=0; i<n; i++){

        size_t idim=i*dim;
        FNumber n=0;
        size_t j;
        #pragma acc loop seq, independent, reduction(+:n)
        for(j=0; j<dim; j++){
#if APPLY_WEIGHT==1
            n+=ga[idim+j]*ga[idim+j]*weight[j];
#else
            n+=ga[idim+j]*ga[idim+j];
#endif
        }
        FNumber w=MKFACT(fn_sqrt(n), alpha);
        #pragma acc loop seq, independent
        for(j=0; j<dim; j++)
            ga[idim+j]=ga[idim+j]*w;
    }
}


#undef WORKER
#undef APPLY_WEIGHT
#undef MKFACT
