/*
 * dticode/tensorreg/fid_fourier_l2alt.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _FID_FOURIER_L2ALT_H
#define _FID_FOURIER_L2ALT_H

#include "tensor.h"
#include "combine.h"
#include "combine_nonlin.h"
#include "matrix.h"
#include "fourier_sample.h"
#include "diffoper.h"
#include "fid_fourier_l2.h"

typedef TensorField FidFourierL2AltPrimal;
typedef TensorField FidFourierL2AltDual;
typedef FidFourierL2Params FidFourierL2AltParams;

void fid_fourier_l2alt_init(const TensorField *f,
                            //const TensorField *mask,
                            //FNumber mask_term_weight,
                            const Sig *sig,
                            size_t n_samples, 
                            const FourierSample *samples,
                            Fid **fid, 
                            FidFourierL2AltParams *param);

#endif /* _FID_FOURIER_L2ALT_H */
