/*
 * dticode/tensorreg/fid_frob_l1.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _FID_TENSORFROB_L1_H
#define _FID_TENSORFROB_L1_H

#include "tensor.h"
#include "combine.h"
#include "matrix.h"

typedef TensorField FidTFL1Primal;
typedef TensorField FidTFL1Dual;

typedef struct{
    const TensorField *f;
    const Matrix *amat;
    const Matrix *amat_conj;
    int unconstr;
    FNumber pdgap0;
    double ubound;
} FidTFL1Params;

void fid_frob_l1_init(const TensorField *f,
                      const Matrix *amat,
                      int unconstr,
                      Fid **fid, 
                      FidTFL1Params *param);

#endif /* _FID_TENSORFROB_L1_H */
