/*
 * dticode/tensorreg/fid_frob_l2.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */


#ifndef _FID_TENSORFROB_L2_H
#define _FID_TENSORFROB_L2_H

#include "tensor.h"
#include "combine.h"
#include "matrix.h"

typedef TensorField FidTFL2Primal;
typedef void FidTFL2Dual;

typedef struct{
    const TensorField *f;
    const Matrix *amat;
    const Matrix *amat_conj;
    int unconstr;
    FNumber pdgap0;
    FNumber a_squared_bound;
    FNumber iprho;
} FidTFL2Params;

void fid_frob_l2_init(const TensorField *f,
                      const Matrix *amat,
                      int unconstr,
                      Fid **fid, 
                      FidTFL2Params *param);

#endif /* _FID_TENSORFROB_L2_H */
