/*
 * dticode/tensorreg/fid_frob_l2alt.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */


#ifndef _FID_TENSORFROB_L2ALT_H
#define _FID_TENSORFROB_L2ALT_H

#include "tensor.h"
#include "combine.h"
#include "matrix.h"

typedef TensorField FidTFL2AltPrimal;
typedef TensorField FidTFL2AltDual;

typedef struct{
    const TensorField *f;
    const Matrix *amat;
    const Matrix *amat_conj;
    int unconstr;
    FNumber pdgap0;
    double ubound;
} FidTFL2AltParams;

void fid_frob_l2alt_init(const TensorField *f,
                         const Matrix *amat,
                         int unconstr,
                         Fid **fid, 
                         FidTFL2AltParams *param);

#endif /* _FID_TENSORFROB_L2ALT_H */
