/*
 * dticode/src/posdef_worker_template.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */

/* Major hack to work around PGCC's 
 *  * Broken handling of _Pragma in macros (converted to #pragma 
 *    without linefeed thereafter), 
 *  * Failure to inline functions passed by pointers.
 */
static int WORKER(size_t dim, size_t n, const FNumber * restrict DEVPTR a, 
                  char * restrict pd, FNumber threshold)
{
    int all_pd=1;
    size_t i;
   
    if(pd){
        #pragma omp parallel for reduction(&:all_pd)
        #pragma acc kernels loop deviceptr(a), \
            copy(pd[0:n]), \
            reduction(&:all_pd)
        for(i=0; i<n; i++){
            int b=SYLVESTER(a+dim*i, threshold);
            pd[i]=b;
            all_pd=all_pd & b;
        }
    }else{
        size_t dimn=n*dim;
        #pragma omp parallel for reduction(&:all_pd)
        #pragma acc kernels loop deviceptr(a), \
            reduction(&:all_pd)
        /*for(i=0; i<dimn; i+=dim){
            int b=SYLVESTER(a+i, threshold);*/
        for(i=0; i<n; i++){
            int b=SYLVESTER(a+dim*i, threshold);
            /* Do it this way to help detect reductions */
            all_pd=all_pd & b;
        }
    }
    return all_pd;
}

#undef WORKER
#undef SYLVESTER
