/*
 * dticode/src/reg.h
 *
 * Written 2013 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _REG_H 
#define _REG_H

#include "reg_tv.h"
#include "reg_tgv2.h"
#include "reg_split.h"
#include "cpock_accel.h"

typedef union{
    RegTVParams tv;
    RegTGV2Params tgv2;
    RegSplitParams split;
} RegP;

void scan_regulariser(char **regname, FNumber *alpha, FNumber *beta, const char *param);

void init_regulariser(Reg **reg, RegP *regp, const char *regname_param, 
                      const Sig *sig, const char *diffalg);

#endif /* _REG_H */
