/*
 * dticode/src/reg_operl2.h
 *
 * Written 2014 by Tuomo Valkonen <tuomov@iki.fi>, EPN Quito / Modemat.
 *
 */


#ifndef _REG_OPERL2_H 
#define _REG_OPERL2_H

#include <libtu/types.h>
#include "cpock_accel.h"
#include "combine.h"
#include "number.h"
#include "tensor.h"
#include "linoper.h"

typedef struct{
    FNumber alpha;
    FNumber pdgap0;
    LinOper *oper;
} RegOperL2Params;

extern void reg_operl2_init(LinOper *oper, FNumber alpha, 
                            Reg **reg, RegOperL2Params *l2p);

extern void reg_gradl2_init(const Sig *sig, bool symmetric, 
                            FNumber alpha, const char *diffalg,
                            Reg **reg, RegOperL2Params *l2p);

#endif /* _REG_OPERL2_H */
