/*
 * dticode/src/reg_tdiv.h
 *
 * Written 2014 by Tuomo Valkonen <tuomov@iki.fi>, University of Cambridge.
 *
 */


#ifndef _REG_TDIV_H 
#define _REG_TDIV_H

#include <libtu/types.h>
#include "cpock_accel.h"
#include "combine.h"
#include "number.h"
#include "tensor.h"

typedef struct{
    FNumber alpha;
    FNumber pdgap0;
    char diffalg;
    bool td;
    Sig sig;
    FNumber huber;
} RegTDivParams;

extern void reg_tdiv_init(const Sig *sig, bool td, FNumber alpha, FNumber huber,
                          const char *diffalg, Reg **reg, RegTDivParams *tvp);

#endif /* _REG_TDIV_H */
