/*
 * dticode/src/reg_tgv2.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */


#ifndef _REG_TGV2_H 
#define _REG_TGV2_H

#include <libtu/types.h>
#include "cpock_accel.h"
#include "combine.h"
#include "number.h"
#include "tensor.h"

typedef struct{
    FNumber alpha;
    FNumber beta;
    char diffalg1;
    char diffalg2;
    FNumber pdgap0_ab, pdgap0_c; // pdgap0=pdgap0_ab+m2*pdgap0_c;
    FNumber m2;
    Sig sig;
} RegTGV2Params;

extern void reg_tgv2_init(const Sig *sig, FNumber alpha, FNumber beta, 
                          const char *diffalg, Reg **reg, RegTGV2Params *tgv2p);

#endif /* _REG_TGV2_H */
