/*
 * dticode/src/scaleplus_worker_template.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */

/* Major hack to work around PGCC's 
 *  * Broken handling of _Pragma in macros (converted to #pragma 
 *    without linefeed thereafter), 
 *  * Failure to inline functions passed by pointers.
 */
static void WORKER(size_t n, FNumber * restrict DEVPTR res,
                   const FNumber * restrict DEVPTR y, 
                   const FNumber * restrict DEVPTR f,
                   const FNumber gamma, const FNumber tau)
{
    size_t i;
    
    #pragma omp parallel for
    #pragma acc kernels loop gang, vector, independent, \
        deviceptr(y, f, res)
    for(i=0; i<n; i++)
        res[i]=OP(y[i], f[i], gamma, tau);
}

#undef WORKER
#undef OP

