
static void get_combined_primal_i(CombinedPrimal **p_i, CombinedPrimal *p, size_t i)
{
    SplitVar *u=(SplitVar*)COMBINED_U(p);
    SplitVar *w=(SplitVar*)COMBINED_W(p);

    *p_i=alloc_splitvar(2);
    
    COMBINED_U(*p_i)=(Vector*)u->p[i];
    COMBINED_W(*p_i)=(Vector*)w->p[i];
}

static void get_combined_primal_i_const(CombinedPrimal **p_i, const CombinedPrimal *p, size_t i)
{
    SplitVar *u=(SplitVar*)COMBINED_U(p);
    SplitVar *w=(SplitVar*)COMBINED_W(p);

    *p_i=alloc_splitvar(2);

    COMBINED_U(*p_i)=(Vector*)u->p[i];
    COMBINED_W(*p_i)=(Vector*)w->p[i];
}

static void release_combined_primal(CombinedPrimal *p_i)
{
    COMBINED_U(p_i)=NULL;
    COMBINED_W(p_i)=NULL;
    
    destroy_obj((Obj*)p_i);
}

static void get_dual_i(RegDual **d_i, SplitDual *d, size_t i)
{
    *d_i=d->p[i];
}

static void get_dual_i_const(const RegDual **d_i, const SplitDual *d, size_t i)
{
    *d_i=(RegDual*)d->p[i];
}

static void get_primal_i_const(const FidPrimal **p_i, const SplitPrimal *p, size_t i)
{
    *p_i=p->p[i];
}

static void get_primal_i(FidPrimal **p_i, SplitPrimal *p, size_t i)
{
    *p_i=p->p[i];
}

static void get_extraprimal_i(RegExtraPrimal **p_i, SplitExtraPrimal *p, size_t i)
{
    *p_i=p->p[i];
}

static void get_extraprimal_i_const(const RegExtraPrimal **p_i, const SplitExtraPrimal *p, size_t i)
{
    *p_i=(RegExtraPrimal*)p->p[i];
}
