/*
 * dticode/src/sylvester.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */


#ifndef _SYLVESTER_H
#define _SYLVESTER_H

#include "number.h"
#include "sym2multi2.h"
#include "sym2multi3.h"

static __inline__ int sylvester_3(const FNumber *vst, const FNumber threshold)
{
    /* Sylvester's criterion */
    int posdef=(vst[I_XX]>=threshold);
    if(posdef){
        FNumber det2=vst[I_XX]*vst[I_YY]-vst[I_XY]*vst[I_XY];
        posdef=(det2>=threshold);
        if(posdef){
            FNumber det3=det2*vst[I_ZZ]
                        +vst[I_XZ]*(vst[I_XY]*vst[I_YZ]-vst[I_YY]*vst[I_XZ])
                        -vst[I_YZ]*(vst[I_XX]*vst[I_YZ]-vst[I_XY]*vst[I_XZ]);
            posdef=(det3>=threshold);
        }
    }
    return posdef;
}

static __inline__ int sylvester_2(const FNumber *vst, const FNumber threshold)
{
    /* Sylvester's criterion */
    int posdef=(vst[I2_XX]>=threshold);
    if(posdef){
        FNumber det2=vst[I2_XX]*vst[I2_YY]-vst[I2_XY]*vst[I2_XY];
        posdef=(det2>=threshold);
    }
    return posdef;
}

static __inline__ int sylvester_1(const FNumber *vst, const FNumber threshold)
{
    return (vst[I2_XX]>=threshold);
}

#endif /* _SYLVESTER_H */
