/*
 * dticode/src/tensornorm.c
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */

#include <libtu/output.h>
#include <math.h>
#include <stdio.h>

#include "tensornorm.h"
#include "normalise.h"
#include "sumdot1.h"
#include "number.h"


FNumber tensorfield_frob1(const TensorField *t)
{
    return tensorfield_sumdot1(t, t, FALSE, 2);
}

FNumber tensorfield_frob2(const TensorField *t)
{
    return fn_sqrt(tensorfield_sumdot1(t, t, FALSE, 1));
}

FNumber tensorfield_frob222(const TensorField *t)
{
    return tensorfield_sumdot1(t, t, FALSE, 1)/2;
}

FNumber tensorfield_frob2dist22(const TensorField *t, const TensorField *t2)
{
    return tensorfield_sumdot1(t, t2, TRUE, 1)/2;
}

FNumber tensorfield_frob2dist(const TensorField *t, const TensorField *t2)
{
    return fn_sqrt(tensorfield_sumdot1(t, t2, TRUE, 1));
}

FNumber tensorfield_iprod(const TensorField *t, const TensorField *t2)
{
    return tensorfield_sumdot1(t, t2, FALSE, 1);
}

FNumber tensorfield_frobinf(const TensorField *t)
{
    return tensorfield_infdot1(t, t, FALSE, 2);
}

