/*
 * dticode/src/varmatrix.h
 *
 * Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
 *
 */

/* Storage of small matrices in multiple variables instead of an
 * array, to optimise GPU code.
 */
#ifndef _VARMATRIX_H
#define _VARMATRIX_H

#include "sym2multi3.h"
#include "sym2multi2.h"
#include "number.h"

#define NAME_VARMATRIX(A, I) A##_##I
#define VAR_VARMATRIX(A, I) NAME_VARMATRIX(A, I)

#define DEFINE_VARMATRIX_SYM3(A) \
    FNumber VAR_VARMATRIX(A, I_XX)=0, \
            VAR_VARMATRIX(A, I_XY)=0, \
            VAR_VARMATRIX(A, I_YY)=0, \
            VAR_VARMATRIX(A, I_XZ)=0, \
            VAR_VARMATRIX(A, I_YZ)=0, \
            VAR_VARMATRIX(A, I_ZZ)=0

#define DEFINE_INIT_VARMATRIX_SYM3(A, M) \
    FNumber VAR_VARMATRIX(A, I_XX)=M[I_XX], \
            VAR_VARMATRIX(A, I_XY)=M[I_XY], \
            VAR_VARMATRIX(A, I_YY)=M[I_YY], \
            VAR_VARMATRIX(A, I_XZ)=M[I_XZ], \
            VAR_VARMATRIX(A, I_YZ)=M[I_YZ], \
            VAR_VARMATRIX(A, I_ZZ)=M[I_ZZ]

#define DEFINE_VARMATRIX_3(A) \
    FNumber VAR_VARMATRIX(A, INS_XX)=0, \
            VAR_VARMATRIX(A, INS_XY)=0, \
            VAR_VARMATRIX(A, INS_XZ)=0, \
            VAR_VARMATRIX(A, INS_YX)=0, \
            VAR_VARMATRIX(A, INS_YY)=0, \
            VAR_VARMATRIX(A, INS_YZ)=0, \
            VAR_VARMATRIX(A, INS_ZX)=0, \
            VAR_VARMATRIX(A, INS_ZY)=0, \
            VAR_VARMATRIX(A, INS_ZZ)=0

#define DEFINE_VARMATRIX_SYM2(A) \
    FNumber VAR_VARMATRIX(A, I2_XX)=0, \
            VAR_VARMATRIX(A, I2_XY)=0, \
            VAR_VARMATRIX(A, I2_YY)=0

#define DEFINE_VARMATRIX_2(A) \
    FNumber VAR_VARMATRIX(A, INS2_XX)=0, \
            VAR_VARMATRIX(A, INS2_XY)=0, \
            VAR_VARMATRIX(A, INS2_YX)=0, \
            VAR_VARMATRIX(A, INS2_YY)=0

#endif /* _VARMATRIX_H */
