function [ discr ] = calc_disc_from_sigma(avg_sigma0,avg_sigma1,d0,mask)
% this function calculates discrepancy given a certain noise levels and I
% data

% for now only 1st measurement is taken as 0 measurement.
s=size(d0.I);
I0=d0.I(:,:,:,1);
I1=d0.I(:,:,:,2:s(4));

I0=reshape(I0,[s(1)*s(2)*s(3) 1]);
I1=reshape(I1,[s(1)*s(2)*s(3) s(4)-1]);

%add points to mask where I0 is small;
mask1=I0<10;
mask_size0=sum(mask);
mask(mask1)=false;
mask_size1=sum(mask);

I0_masked=I0(mask, 1);
I1_masked=I1(mask,:);

res=I1_masked*0;
res_noise=res;

for j=1:(s(4)-1)
  res(:,j)=log(I1_masked(:,j)./I0_masked);
  %res_noise(:,j)=log((I1_masked(:,j)+avg_sigma1)./(I0_masked-avg_sigma0));
  res_noise(:,j)=avg_sigma1./I1_masked(:,j)+avg_sigma0./I0_masked;
end;
res=res/d0.bval(2);
res_noise=res_noise/d0.bval(2);
%discr=norm(res-res_noise);
discr=norm(res_noise)*mask_size0/mask_size1;