% Sample script to convert NIFTI data for tensorreg, 
% adding noise. This script exports the raw DWI signals
% for the whole 3D volume, as well as the tensors.
%

%
% Set up parameters for script
%
noises=0.4;%[0 10 30 50 70];


% Export whole brain
slice=[];
BASEPREFIX='Program/examples/experiment_simulated/helix-sumulated';
load('matlab/dti phantom generator/I_data.mat')

% Use all DWI signals
partial=[];
% Use only signals 1:7
%partial=1:7;


%
% Load data (NIFTI format)
%


[sig, f0, mask]=dti_data_to_tensor(d0, 0);

if ~isempty(partial)
    d0.bvec=d0.bvec(:, partial);
    d0.bval=d0.bval(:, partial);
    d0.I=d0.I(:, :, :, partial);
end

%
% Export noise-free data as raw doubles
%

%
% Generate and export noisy data as raw doubles
%
for j=1:length(noises)
    noise=noises(j);
    d=d0;
    if noise~=0
        d.I=ricernd(d0.I, noise);
    end
    [sig, f]=dti_data_to_tensor(d, 0);
    
    nameraw=sprintf('%s_raw_f%d', BASEPREFIX, noise);
    namenl=sprintf('%s-nl-rician-%d', BASEPREFIX, noise);
    nameten=sprintf('%s_ten_f%d', BASEPREFIX, noise);
    nameind=sprintf('%s_ind_f%d', BASEPREFIX, noise);
    %for i=1:length(algs)
    %    tensorreg_export_raw(nameraw, d, ...
    %        a_dwi, b_dwi, algs{i}, rho, iters);
    %    tensorreg_export(nameten, sig, f, mask, ...
    %        a_ten, b_ten, algs{i}, rho, iters);
    %end
    %tensorreg_export_raw(nameraw, d);
    %tensorreg_export(nameten, sig, f, mask);
    %tensorreg_export_individual(nameind, d);
    tensorreg_export_raw_s0(namenl, d, f, 2);
end

