%This script generates ground-truth helix-shaped tensor-field
I=zeros(6,100,100,30);  %tensor field

s=size(I);
x=linspace(0,1,s(2));  %coordinates
y=linspace(0,1,s(3));
z=linspace(0,1,s(4));

[helix_xyz, direction_xyz]=g_helix_xyz(0.3,0.07,4*pi);
helix_size=size(helix_xyz);

for i=1:helix_size(1)
    hx=helix_xyz(i,1)+0.5;
    hy=helix_xyz(i,2)+0.5;
    hz=helix_xyz(i,3);
    [C, I1] = min(abs(x-hx));
    [C, I2] = min(abs(y-hy));
    [C, I3] = min(abs(z-hz));
    I(:,I1,I2,I3)=g_tensor(direction_xyz(i,:));
    if mod(i,1000)==0
        i/helix_size(1)
    end;
end;
%scatter3(helix_xyz(:,1),helix_xyz(:,2),helix_xyz(:,3));
%quiver3(helix_xyz(:,1),helix_xyz(:,2),helix_xyz(:,3),direction_xyz(:,1),direction_xyz(:,2),direction_xyz(:,3))
%surface(I(1,:,:,20))
I=I;
write_doubles('Program/examples/experiment_simulated/ground_truth/helix.doubles',reshape(I,[prod(s) 1]));
