function  [helix_xyz, direction_xyz]  = g_helix_xyz( R,r_max,phi_max )
%function returns array of coordinates for 3d helix and its direction
%M=40;
%N=800;
%K=40;
M=3;
N=100;
K=10;
r=linspace(0,r_max,M);
phi=linspace(0,phi_max,N);
tetta=linspace(0,2*pi,K);

helix_xyz1=zeros(M,M,M,3);
direction_xyz1=zeros(M,M,M,3);

for i=1:length(tetta)
    i/M
    for j=1:length(phi)
        for k=1:length(r)
                x=(R+r(k)*cos(tetta(i)))*cos(phi(j));
                y=(R+r(k)*cos(tetta(i)))*sin(phi(j));
                z=r(k)*sin(tetta(i))+phi(j)/phi_max;
                
                helix_xyz1(i,j,k,:)=[x y z];
                
                xd=-R*sin(phi(j));
                yd=R*cos(phi(j));
                zd=1/phi_max;
                
                direction_xyz1(i,j,k,:)=[xd yd zd];
        end;
    end;
end;

helix_xyz=reshape(helix_xyz1,[M*N*K 3]);
direction_xyz=reshape(direction_xyz1,[M*N*K 3]);

end

