clear all;
%load('res.mat')
load('mridata.mat')
A=read_doubles('brain_lownoise_raw-f10-amat.doubles',[48,6]);

xd=128;
yd=128;
zd=60;
frames=48;

res4d=read_doubles('Program/examples/experiment_simulated/ground_truth/helix.doubles',[6 xd yd zd]); %read ground truth tensorfield


I=ones(frames,xd,yd,zd);
for i=1:xd
    for j=1:yd
        for k=1:zd
            v=reshape(res4d(:,i,j,k),[6 1]);
            I(:,i,j,k)=A*v;
        end;
    end;
end;
write_doubles('Program/examples/experiment_simulated/measurements/no_noise.doubles',I)

%mask
avg=reshape(sum(abs(I), 1), 1, xd*yd*zd);
threshold=0.10*max(avg);
mask=avg>threshold;
write_doubles('Program/examples/experiment_simulated/measurements/mask.doubles',mask)
save('Program/examples/experiment_simulated/measurements/mask.mat', 'mask');
%introducing errors in measurements
noise=0.04;
I_temp=log(exp(I)+noise*randn(frames,xd,yd,zd));
surface(reshape(real(I_temp(1,:,:,30)),[128,128]))
write_doubles('Program/examples/experiment_simulated/measurements/normal_noise.doubles',I_temp)
I_temp=-ricernd(I, noise);
write_doubles('Program/examples/experiment_simulated/measurements/rician_noise.doubles',I_temp)
