%
% dticode/matlab/error_frob.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
function psnr=error_frob_psnr(f, u, mask)
    diff=f-u;
    if nargin>2 && ~isempty(mask)
        diff=vecmult(diff, mask);
    end
    f_masked=vecmult(f, mask);
    
    e=symfrob2([sym2dim(f), 2], diff);
    avg_err=(e^2/length(f)*6);
    [maxvalue,argmax]=max(sum(abs(f_masked),1));
    max_matrix=f(:,argmax);
    max_signal=symfrob2([3 2],max_matrix)
    psnr=10*log10(4*max_signal^2/avg_err); % We take twice the maximum for a dynamic range
end
