%
% dticode/matlab/error_peangle.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
function psnr=error_peangle_psnr(f, u, mask)
    [L,E]=sym2eigs_multi_principal(u);
    [Lf,Ef]=sym2eigs_multi_principal(f);
    e1=squeeze(E(1, :, :));
    e1f=squeeze(Ef(1, :, :));
    FA=ev2fractanis(L);
    FAf=ev2fractanis(Lf);
    mask2=(FA>0.01) | (FAf>0.01);
    
    if nargin>2 && ~isempty(mask)
        mask2=mask.*mask2;
    end
    e_mask=(sum(e1(:,:))==0);  % getting rid of points with 0 norm and thus no angle
    mask=mask.*~e_mask;
    
    avg_err=sum((1-abs(dot(e1, e1f, 1))).*mask)/sum(mask);
    psnr = 10*log10(4/avg_err^2);
    
end
