%
% dticode/matlab/error_peval.m
%
% Written 2012 by Tuomo Valkonen <tuomov@iki.fi>, University of Graz.
%
function psnr=error_peval_psnr(f, u, mask)
    L=sym2eigs_multi_principal(u);
    Lf=sym2eigs_multi_principal(f);
    diff=L(1, :)-Lf(1, :);
    if nargin>2 && ~isempty(mask)
        diff=diff.*mask;
    end
    
    max_signal=max(L);
    avg_err=sqrt(sum(diff.^2)/sum(mask));
    
    psnr=10*log10(4*max_signal^2/avg_err^2); 
end
